// --------------------------------------------------------------------
// CPictureDrawerText.cxx
// Whatis:  Scale the image to given size
// Authors: Esko 'Varpu' Ilola  EIL
// History: EIL 24-NOV-2001     Created this source
// --------------------------------------------------------------------
#include	"CError.hxx"
#include	"CPictureDrawerText.hxx"

// --------------------------------------------------------------------
// local:	The character font
// --------------------------------------------------------------------
const char *	localfont[] = {
//			0x0			0x1			0x2			0x3
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",

//			0x4			0x5			0x6			0x7
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",

//			0x8			0x9			0xa			0xb
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",

//			0xc			0xd			0xe			0xf
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",
			"         ","         ","         ","         ",

//			0x10			0x11			0x12			0x13
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x14			0x15			0x16			0x17
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x18			0x19			0x1a			0x1b
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x1c			0x1d			0x1e			0x1f
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x20			0x21'!'			0x22'"'			0x23'#'
			"         ",	"         ",	"         ",	"         ",
			"         ",	"   xxx   ",	"   x x   ",	"         ",
			"         ",	"   xxx   ",	"   x x   ",	"         ",
			"         ",	"   xxx   ",	"   x x   ",	"  x  x   ",
			"         ",	"   xxx   ",	"         ",	"  x  x   ",
			"         ",	"   xxx   ",	"         ",	"xxxxxxxx ",
			"         ",	"   xxx   ",	"         ",	"  x  x   ",
			"         ",	"   xxx   ",	"         ",	"  x  x   ",
			"         ",	"    x    ",	"         ",	"xxxxxxxx ",
			"         ",	"         ",	"         ",	"  x  x   ",
			"         ",	"    x    ",	"         ",	"  x  x   ",
			"         ",	"   xxx   ",	"         ",	"         ",
			"         ",	"    x    ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x24'$'			0x25'%'			0x26'&'			0x27'''
			"         ",	"         ",	"         ",	"         ",
			"  x  x   ",	" xx    x ",	"         ",	"         ",
			"  xxxx   ",	"x  x   x ",	"         ",	"         ",
			" xx  xx  ",	"x  x  x  ",	"         ",	"         ",
			"x x  x x ",	" xx  x   ",	"         ",	"         ",
			"x x  x   ",	"    x    ",	"         ",	"         ",
			" xx  x   ",	"    x    ",	"         ",	"         ",
			"  xxxx   ",	"   x     ",	"         ",	"         ",
			"  x  xx  ",	"  x      ",	"         ",	"         ",
			"  x  x x ",	"  x  xx  ",	"         ",	"         ",
			"x x  x x ",	" x  x  x ",	"         ",	"         ",
			" xx  xx  ",	"x   x  x ",	"         ",	"         ",
			"  xxxx   ",	"x    xx  ",	"         ",	"         ",
			"  x  x   ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x28'('			0x29')'			0x2a'*'			0x2b'+'
			"         ",	"         ",	"         ",	"         ",
			"    x    ",	"x        ",	"         ",	"         ",
			"   x     ",	" x       ",	"         ",	"         ",
			"  x      ",	"  x      ",	"         ",	"         ",
			" x       ",	"   x     ",	"   x     ",	"   x     ",
			" x       ",	"   x     ",	" x x x   ",	"   x     ",
			"x        ",	"    x    ",	"  xxx    ",	"   x     ",
			"x        ",	"    x    ",	"xxxxxxx  ",	"xxxxxxx  ",
			"x        ",	"    x    ",	"  xxx    ",	"   x     ",
			" x       ",	"   x     ",	" x x x   ",	"   x     ",
			" x       ",	"   x     ",	"   x     ",	"   x     ",
			"  x      ",	"  x      ",	"         ",	"         ",
			"   x     ",	" x       ",	"         ",	"         ",
			"    x    ",	"x        ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x2c','			0x2d'-'			0x2e'.'			0x2f'/'
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"       x ",
			"         ",	"         ",	"         ",	"       x ",
			"         ",	"         ",	"         ",	"      x  ",
			"         ",	"         ",	"         ",	"     x   ",
			"         ",	"         ",	"         ",	"    x    ",
			"         ",	"         ",	"         ",	"    x    ",
			"         ",	"xxxxxxx  ",	"         ",	"   x     ",
			"         ",	"         ",	"         ",	"   x     ",
			"         ",	"         ",	"         ",	"  x      ",
			"         ",	"         ",	"         ",	" x       ",
			"   xx    ",	"         ",	"   xx    ",	"x        ",
			"   xx    ",	"         ",	"   xx    ",	"x        ",
			"    x    ",	"         ",	"         ",	"         ",
			"   x     ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x30'0'			0x31'1'			0x32'2'			0x33'3'
			"         ",	"         ",	"         ",	"         ",
			"  xxxx   ",	"    x    ",	"  xxxx   ",	"  xxxx   ",
			" x    x  ",	"   xx    ",	" x    x  ",	" x    x  ",
			"x      x ",	"  x x    ",	"x      x ",	"x      x ",
			"x      x ",	"    x    ",	"x      x ",	"       x ",
			"x      x ",	"    x    ",	"      x  ",	"      x  ",
			"x      x ",	"    x    ",	"     x   ",	"   xxx   ",
			"x      x ",	"    x    ",	"    x    ",	"      x  ",
			"x      x ",	"    x    ",	"   x     ",	"       x ",
			"x      x ",	"    x    ",	"  x      ",	"       x ",
			"x      x ",	"    x    ",	" x       ",	"x      x ",
			" x    x  ",	"    x    ",	"x        ",	" x    x  ",
			"  xxxx   ",	"  xxxxx  ",	"xxxxxxxx ",	"  xxxx   ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x34'4'			0x35'5'			0x36'6'			0x37'7'
			"         ",	"         ",	"         ",	"         ",
			"    xx   ",	"xxxxxxxx ",	"  xxxx   ",	"xxxxxxxx ",
			"   x x   ",	"x        ",	" x       ",	"x      x ",
			"  x  x   ",	"x        ",	"x        ",	"      x  ",
			" x   x   ",	"x        ",	"x        ",	"     x   ",
			"x    x   ",	"x        ",	"x        ",	"     x   ",
			"xxxxxxxx ",	"xxxxxx   ",	"x xxxx   ",	"    x    ",
			"     x   ",	"      x  ",	"xx    x  ",	"   x     ",
			"     x   ",	"       x ",	"x      x ",	"   x     ",
			"     x   ",	"       x ",	"x      x ",	"  x      ",
			"     x   ",	"x      x ",	"x      x ",	" x       ",
			"     x   ",	" x    x  ",	" x    x  ",	" x       ",
			"   xxxxx ",	"  xxxx   ",	"  xxxx   ",	" x       ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x38'8'			0x39'9'			0x3a':'			0x3b';'
			"         ",	"         ",	"         ",	"         ",
			"  xxxx   ",	"  xxxx   ",	"         ",	"         ",
			" x    x  ",	" x    x  ",	"         ",	"         ",
			"x      x ",	"x      x ",	"   xx    ",	"   xx    ",
			"x      x ",	"x      x ",	"   xx    ",	"   xx    ",
			" x    x  ",	"x      x ",	"         ",	"         ",
			"  xxxx   ",	" x    xx ",	"         ",	"         ",
			" x    x  ",	"  xxxx x ",	"         ",	"         ",
			"x      x ",	"       x ",	"         ",	"         ",
			"x      x ",	"       x ",	"   xx    ",	"   xx    ",
			"x      x ",	"       x ",	"   xx    ",	"   xx    ",
			" x    x  ",	"      x  ",	"         ",	"    x    ",
			"  xxxx   ",	"  xxxx   ",	"         ",	"   x     ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x3c'<'			0x3d'='			0x3e'>'			0x3f'?'
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"  xxxx   ",
			"         ",	"         ",	"         ",	" x    x  ",
			"         ",	"         ",	"         ",	"x      x ",
			"    x    ",	"         ",	"x        ",	"x      x ",
			"   x     ",	"         ",	" x       ",	"       x ",
			"  x      ",	"xxxxxxxx ",	"  x      ",	"      x  ",
			" x       ",	"         ",	"   x     ",	"     x   ",
			"x        ",	"xxxxxxxx ",	"    x    ",	"    x    ",
			" x       ",	"         ",	"   x     ",	"    x    ",
			"  x      ",	"         ",	"  x      ",	"         ",
			"   x     ",	"         ",	" x       ",	"   xx    ",
			"    x    ",	"         ",	"x        ",	"   xx    ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x40'@'			0x41'A'			0x42'B'			0x43'C'
			"         ",	"         ",	"         ",	"         ",
			"  xxxx   ",	"  xxxx   ",	"xxxxxx   ",	"  xxxx   ",
			" x    x  ",	" x    x  ",	"x     x  ",	" x    x  ",
			"x      x ",	"x      x ",	"x      x ",	"x      x ",
			"x      x ",	"x      x ",	"x      x ",	"x      x ",
			"x  xxx x ",	"x      x ",	"x     x  ",	"x        ",
			"x  x x x ",	"xxxxxxxx ",	"xxxxxx   ",	"x        ",
			"x  x x x ",	"x      x ",	"x     x  ",	"x        ",
			"x  x x x ",	"x      x ",	"x      x ",	"x        ",
			"x  xxxx  ",	"x      x ",	"x      x ",	"x      x ",
			"x        ",	"x      x ",	"x      x ",	"x      x ",
			" x       ",	"x      x ",	"x     x  ",	" x    x  ",
			"  xxxx   ",	"x      x ",	"xxxxxx   ",	"  xxxx   ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x44'D'			0x45'E'			0x46'F'			0x47'G'
			"         ",	"         ",	"         ",	"         ",
			"xxxxxx   ",	"xxxxxxxx ",	"xxxxxxxx ",	"  xxxx   ",
			"x     x  ",	"x        ",	"x        ",	" x    x  ",
			"x      x ",	"x        ",	"x        ",	"x      x ",
			"x      x ",	"x        ",	"x        ",	"x      x ",
			"x      x ",	"x        ",	"x        ",	"x        ",
			"x      x ",	"xxxxxx   ",	"xxxxxx   ",	"x        ",
			"x      x ",	"x        ",	"x        ",	"x  xxxxx ",
			"x      x ",	"x        ",	"x        ",	"x      x ",
			"x      x ",	"x        ",	"x        ",	"x      x ",
			"x      x ",	"x        ",	"x        ",	"x      x ",
			"x     x  ",	"x        ",	"x        ",	" x    x  ",
			"xxxxxx   ",	"xxxxxxxx ",	"x        ",	"  xxxx   ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x48'H'			0x49'I'			0x4a'J'			0x4b'K'
			"         ",	"         ",	"         ",	"         ",
			"x      x ",	"   xxx   ",	"     xxx ",	"x      x ",
			"x      x ",	"    x    ",	"      x  ",	"x     x  ",
			"x      x ",	"    x    ",	"      x  ",	"x    x   ",
			"x      x ",	"    x    ",	"      x  ",	"x   x    ",
			"x      x ",	"    x    ",	"      x  ",	"x  x     ",
			"x      x ",	"    x    ",	"      x  ",	"x x      ",
			"xxxxxxxx ",	"    x    ",	"      x  ",	"xxx      ",
			"x      x ",	"    x    ",	"      x  ",	"x  x     ",
			"x      x ",	"    x    ",	"x     x  ",	"x   x    ",
			"x      x ",	"    x    ",	"x     x  ",	"x    x   ",
			"x      x ",	"    x    ",	" x   x   ",	"x     x  ",
			"x      x ",	"   xxx   ",	"  xxx    ",	"x      x ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x4c'L'			0x4d'M'			0x4e'N'			0x4f'O'
			"         ",	"         ",	"         ",	"         ",
			"x        ",	"x      x ",	"x      x ",	"  xxxx   ",
			"x        ",	"xx    xx ",	"xx     x ",	" x    x  ",
			"x        ",	"x x  x x ",	"x x    x ",	"x      x ",
			"x        ",	"x  xx  x ",	"x x    x ",	"x      x ",
			"x        ",	"x      x ",	"x x    x ",	"x      x ",
			"x        ",	"x      x ",	"x  x   x ",	"x      x ",
			"x        ",	"x      x ",	"x   x  x ",	"x      x ",
			"x        ",	"x      x ",	"x    x x ",	"x      x ",
			"x        ",	"x      x ",	"x    x x ",	"x      x ",
			"x        ",	"x      x ",	"x    x x ",	"x      x ",
			"x        ",	"x      x ",	"x     xx ",	" x    x  ",
			"xxxxxxxx ",	"x      x ",	"x      x ",	"  xxxx   ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x50'P'			0x51'Q'			0x52'R'			0x53'S'
			"         ",	"         ",	"         ",	"         ",
			"xxxxxx   ",	"  xxxx   ",	"xxxxxx   ",	"  xxxx   ",
			"x     x  ",	" x    x  ",	"x     x  ",	" x    x  ",
			"x      x ",	"x      x ",	"x      x ",	"x      x ",
			"x      x ",	"x      x ",	"x      x ",	"x        ",
			"x      x ",	"x      x ",	"x      x ",	" x       ",
			"x     x  ",	"x      x ",	"x     x  ",	"  xxxx   ",
			"xxxxxx   ",	"x      x ",	"xxxxxx   ",	"      x  ",
			"x        ",	"x      x ",	"x   x    ",	"       x ",
			"x        ",	"x      x ",	"x    x   ",	"       x ",
			"x        ",	"x   x  x ",	"x     x  ",	"x      x ",
			"x        ",	" x  x x  ",	"x      x ",	" x    x  ",
			"x        ",	"  xxxxx  ",	"x      x ",	"  xxxx   ",
			"         ",	"       x ",	"         ",	"         ",
			"         ",	"       x ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x54'T'			0x55'U'			0x56'V'			0x57'W'
			"         ",	"         ",	"         ",	"         ",
			" xxxxxxx ",	"x      x ",	"x      x ",	"x     x  ",
			"    x    ",	"x      x ",	"x      x ",	"x     x  ",
			"    x    ",	"x      x ",	"x      x ",	"x     x  ",
			"    x    ",	"x      x ",	"x      x ",	"x     x  ",
			"    x    ",	"x      x ",	"x      x ",	"x     x  ",
			"    x    ",	"x      x ",	"x      x ",	"x  x  x  ",
			"    x    ",	"x      x ",	"x      x ",	"x  x  x  ",
			"    x    ",	"x      x ",	"x      x ",	"x  x  x  ",
			"    x    ",	"x      x ",	"x      x ",	" x x x   ",
			"    x    ",	"x      x ",	" x    x  ",	" x x x   ",
			"    x    ",	" x    x  ",	"  x  x   ",	"  x x    ",
			"    x    ",	"  xxxx   ",	"   xx    ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x58'X'			0x59'Y'			0x5a'Z'			0x5b'['
			"         ",	"         ",	"         ",	"         ",
			"x      x ",	"x     x  ",	"xxxxxxxx ",	"xxxx     ",
			"x      x ",	"x     x  ",	"       x ",	"x        ",
			"x      x ",	"x     x  ",	"      x  ",	"x        ",
			" x    x  ",	" x   x   ",	"     x   ",	"x        ",
			"  x  x   ",	"  x x    ",	"    x    ",	"x        ",
			"   xx    ",	"   x     ",	"    x    ",	"x        ",
			"   xx    ",	"   x     ",	"   x     ",	"x        ",
			"  x  x   ",	"   x     ",	"   x     ",	"x        ",
			" x    x  ",	"   x     ",	"  x      ",	"x        ",
			"x      x ",	"   x     ",	" x       ",	"x        ",
			"x      x ",	"   x     ",	"x        ",	"x        ",
			"x      x ",	"   x     ",	"xxxxxxxx ",	"xxxx     ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x5c'\'			0x5d']'			0x5e'^'			0x5f'_'
			"         ",	"         ",	"         ",	"         ",
			"x        ",	"xxxx     ",	"   x     ",	"         ",
			"x        ",	"   x     ",	"  x x    ",	"         ",
			" x       ",	"   x     ",	" x   x   ",	"         ",
			"  x      ",	"   x     ",	"x     x  ",	"         ",
			"   x     ",	"   x     ",	"         ",	"         ",
			"   x     ",	"   x     ",	"         ",	"         ",
			"    x    ",	"   x     ",	"         ",	"         ",
			"     x   ",	"   x     ",	"         ",	"         ",
			"     x   ",	"   x     ",	"         ",	"         ",
			"      x  ",	"   x     ",	"         ",	"         ",
			"       x ",	"   x     ",	"         ",	"         ",
			"       x ",	"xxxx     ",	"         ",	"xxxxxxxx ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x60'`'			0x61'a'			0x62'b'			0x63'c'
			"         ",	"         ",	"         ",	"         ",
			"    x    ",	"         ",	"         ",	"         ",
			"    x    ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"x        ",	"         ",
			"         ",	"         ",	"x        ",	"         ",
			"         ",	"         ",	"x        ",	"         ",
			"         ",	"         ",	"x        ",	"         ",
			"         ",	" xxxx    ",	"x xxx    ",	"  xxx    ",
			"         ",	"     x   ",	"xx   x   ",	" x   x   ",
			"         ",	" xxxxx   ",	"x     x  ",	"x        ",
			"         ",	"x    x   ",	"x     x  ",	"x        ",
			"         ",	"x    x   ",	"xx   x   ",	" x   x   ",
			"         ",	" xxxx x  ",	"x xxx    ",	"  xxx    ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x64'd'			0x65'e'			0x66'f'			0x67'g'
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"      x  ",	"         ",	"         ",	"         ",
			"      x  ",	"         ",	"         ",	"         ",
			"      x  ",	"         ",	"         ",	"         ",
			"      x  ",	"         ",	"  xx     ",	"         ",
			"  xxx x  ",	" xxxx    ",	" x  x    ",	"         ",
			" x   xx  ",	"x    x   ",	" x       ",	" xxx x   ",
			"x     x  ",	"xxxxxx   ",	" x       ",	"x   xx   ",
			"x     x  ",	"x        ",	"xxx      ",	"x   xx   ",
			" x   xx  ",	"x    x   ",	" x       ",	" xxx x   ",
			"  xxx x  ",	" xxxx    ",	" x       ",	"     x   ",
			"         ",	"         ",	"         ",	" x   x   ",
			"         ",	"         ",	"         ",	"  xxx    ",
			"         ",	"         ",	"         ",	"         ",

//			0x68'h'			0x69'i'			0x6a'j'			0x6b'k'
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"x        ",	"  x      ",	"   x     ",	"x        ",
			"x        ",	"         ",	"         ",	"x        ",
			"x        ",	" xx      ",	" xxx     ",	"x  xx    ",
			"x xx     ",	"  x      ",	"   x     ",	"x x      ",
			"xx  x    ",	"  x      ",	"   x     ",	"xxx      ",
			"x   x    ",	"  x      ",	"   x     ",	"x  x     ",
			"x   x    ",	"  x      ",	"x  x     ",	"x   x    ",
			"x   x    ",	" xxx     ",	" xx      ",	"x    x   ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x6c'l'			0x6d'm'			0x6e'n'			0x6f'o'
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			" xx      ",	"         ",	"         ",	"         ",
			"  x      ",	"         ",	"         ",	"         ",
			"  x      ",	"         ",	"         ",	"         ",
			"  x      ",	"xxx xx   ",	"x xxx    ",	"  xxx    ",
			"  x      ",	"x  x  x  ",	"xx   x   ",	" x   x   ",
			"  x      ",	"x  x  x  ",	"x    x   ",	" x   x   ",
			"  x      ",	"x  x  x  ",	"x    x   ",	" x   x   ",
			" xxx     ",	"x  x  x  ",	"x    x   ",	"  xxx    ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x70'p'			0x71'q'			0x72'r'			0x73's'
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"x xx     ",	" xx x    ",	"x xxx    ",	"         ",
			"xx  x    ",	"x  xx    ",	"xx   x   ",	" xxxxx   ",
			"x   x    ",	"x   x    ",	"x        ",	"x        ",
			"xx  x    ",	"x  xx    ",	"x        ",	" xxxxx   ",
			"x xx     ",	" xx x    ",	"x        ",	"      x  ",
			"x        ",	"    x    ",	"x        ",	" xxxxx   ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x74't'			0x75'u'			0x76'v'			0x77'w'
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			" x       ",	"         ",	"         ",	"         ",
			" x       ",	"         ",	"         ",	"         ",
			" x       ",	"         ",	"         ",	"         ",
			"xxx      ",	"x   x    ",	"x   x    ",	"x x x    ",
			" x       ",	"x   x    ",	"x   x    ",	"x x x    ",
			" x       ",	"x   x    ",	"x   x    ",	"x x x    ",
			" x       ",	"x   x    ",	"x   x    ",	"x x x    ",
			" x  x    ",	"x   x    ",	" x x     ",	"x x x    ",
			"  xx     ",	" xxx x   ",	"  x      ",	" x x     ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x78'x'			0x79'y'			0x7a'z'			0x7b'{'
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"x        ",
			"         ",	"         ",	"         ",	" x       ",
			"         ",	"         ",	"         ",	" x       ",
			"         ",	"         ",	"         ",	" x       ",
			"         ",	"         ",	"         ",	" x       ",
			"         ",	"         ",	"         ",	" x       ",
			"x    x   ",	"x    x   ",	"xxxxxx   ",	" xx      ",
			" x  x    ",	" x  x    ",	"    x    ",	" x       ",
			"  xx     ",	"  xx     ",	"   x     ",	" x       ",
			"  xx     ",	"  x      ",	"  x      ",	" x       ",
			" x  x    ",	" x       ",	" x       ",	" x       ",
			"x    x   ",	"x        ",	"xxxxxx   ",	"x        ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x7c'|'			0x7d'}'			0x7e'~'			0x7f''
			"         ",	"         ",	"         ",	"         ",
			"   x     ",	"  x      ",	" xx      ",	"         ",
			"   x     ",	" x       ",	"x  x  x  ",	"         ",
			"   x     ",	" x       ",	"    xx   ",	"         ",
			"   x     ",	" x       ",	"         ",	"         ",
			"   x     ",	" x       ",	"         ",	"         ",
			"   x     ",	" x       ",	"         ",	"         ",
			"   x     ",	"xx       ",	"         ",	"         ",
			"   x     ",	" x       ",	"         ",	"         ",
			"   x     ",	" x       ",	"         ",	"         ",
			"   x     ",	" x       ",	"         ",	"         ",
			"   x     ",	" x       ",	"         ",	"         ",
			"   x     ",	"  x      ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x80''			0x81''			0x82''			0x83''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x84''			0x85''			0x86''			0x87''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x88''			0x89''			0x8a''			0x8b''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x8c''			0x8d''			0x8e''			0x8f''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x90''			0x91''			0x92''			0x93''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x94''			0x95''			0x96''			0x97''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x98''			0x99''			0x9a''			0x9b''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0x9c''			0x9d''			0x9e''			0x9f''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xa0' '			0xa1''			0xa2''			0xa3''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xa4''			0xa5''			0xa6''			0xa7''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"    x    ",	"         ",
			"         ",	"         ",	"    x    ",	"         ",
			"         ",	"         ",	"    x    ",	"         ",
			"         ",	"         ",	"    x    ",	"         ",
			"         ",	"         ",	"    x    ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"    x    ",	"         ",
			"         ",	"         ",	"    x    ",	"         ",
			"         ",	"         ",	"    x    ",	"         ",
			"         ",	"         ",	"    x    ",	"         ",
			"         ",	"         ",	"    x    ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xa8''			0xa9''			0xaa''			0xab''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xac''			0xad''			0xae''			0xaf''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"  xxxx   ",	"         ",
			"         ",	"         ",	" x    x  ",	"         ",
			"         ",	"         ",	"x xxx  x ",	"         ",
			"         ",	"         ",	"x x  x x ",	"         ",
			"         ",	"         ",	"x x  x x ",	"         ",
			"         ",	"         ",	"x x  x x ",	"         ",
			"         ",	"         ",	"x xxx  x ",	"         ",
			"         ",	"         ",	"x x  x x ",	"         ",
			"         ",	"         ",	"x x  x x ",	"         ",
			"         ",	"         ",	"x x  x x ",	"         ",
			"         ",	"         ",	" x    x  ",	"         ",
			"         ",	"         ",	"  xxxx   ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xb0''			0xb1''			0xb2''			0xb3''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xb4''			0xb5''			0xb6''			0xb7''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xb8''			0xb9''			0xba''			0xbb''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xbc''			0xbd''			0xbe''			0xbf''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xc0''			0xc1''			0xc2''			0xc3''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xc4''			0xc5''			0xc6''			0xc7''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xc8''			0xc9''			0xca''			0xcb''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xcc''			0xcd''			0xce''			0xcf''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xd0''			0xd1''			0xd2''			0xd3''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xd4''			0xd5''			0xd6''			0xd7''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xd8''			0xd9''			0xda''			0xdb''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xdc''			0xdd''			0xde''			0xdf''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xe0''			0xe1''			0xe2''			0xe3''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xe4''			0xe5''			0xe6''			0xe7''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xe8''			0xe9''			0xea''			0xeb''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xec''			0xed''			0xee''			0xef''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xf0''			0xf1''			0xf2''			0xf3''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xf4''			0xf5''			0xf6''			0xf7''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xf8''			0xf9''			0xfa''			0xfb''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",

//			0xfc''			0xfd''			0xfe''			0xff''
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         ",
			"         ",	"         ",	"         ",	"         "
};


// --------------------------------------------------------------------
// public:	Constructors
// --------------------------------------------------------------------
CPictureDrawerText::CPictureDrawerText ( const char * aText ) {
	CPictureDrawerText::Cleanup();
	CPictureDrawerText::Text( aText );
}

// --------------------------------------------------------------------
CPictureDrawerText::CPictureDrawerText () {
	CPictureDrawerText::Cleanup();
}

// --------------------------------------------------------------------
// public:	Destructor
// --------------------------------------------------------------------
CPictureDrawerText::~CPictureDrawerText () {
	CPictureDrawerText::Free();
}

// --------------------------------------------------------------------
// public:	Copy constructor
// --------------------------------------------------------------------
CPictureDrawerText::CPictureDrawerText( const CPictureDrawerText & aC ) {
	CPictureDrawerText::Cleanup();
	*this = aC;
}

// --------------------------------------------------------------------
// public:	Assignment operators
// --------------------------------------------------------------------
CPictureDrawerText & CPictureDrawerText::operator = ( const CPictureDrawerText & aC ) {
	CPictureDrawerText::Text( aC.Text() );
	CPictureDrawerText::FG( aC.FG() );
	CPictureDrawerText::BG( aC.BG() );
	return *this;
}

// --------------------------------------------------------------------
CPictureDrawerText & CPictureDrawerText::operator = ( const char * aText ) {
	CPictureDrawerText::Text( aText );
	return *this;
}

// --------------------------------------------------------------------
// public:	The actual worker
// --------------------------------------------------------------------
void	CPictureDrawerText::Draw ( dword_t aX, dword_t aY, CPicturePixmap & aP ) {
	const char *	ps	= itsText;
	dword_t			fp;
	const char *	fs;
	dword_t			xp	= aX;
	dword_t			x, y;
	word_t			ami, amb;
	CPicturePixel	pixel;

	if	( ( ps ) && ( aY < aP.H() ) ) {

		while	( ( *ps ) && ( xp < aP.W() ) ) {
			fp = *ps;
			fp &= 0xff;
			fp = (fp / 4)  * DRAWER_FONT_H * 4 + (fp % 4);

			for	( y = 0; y < DRAWER_FONT_H; y++ ) {
				if	( aY + y >= aP.H() )	break;

				fs = localfont[fp];
				fp = fp + 4;
				for	( x = 0; x < DRAWER_FONT_W; x++ ) {
					if	( aX + x >= aP.W() )	break;

					pixel = aP.Pixel( x + xp, y + aY );


					if	( *(fs++) != ' ' ) {
						amb = (word_t)itsFG.A();
						ami = (word_t)(255 - amb);
						pixel.R( (byte_t)( (amb * itsFG.R() + ami * (word_t)pixel.R()) / 255 ) );
						pixel.G( (byte_t)( (amb * itsFG.G() + ami * (word_t)pixel.G()) / 255 ) );
						pixel.B( (byte_t)( (amb * itsFG.B() + ami * (word_t)pixel.B()) / 255 ) );
					}
					else {
						amb = (word_t)itsBG.A();
						ami = (word_t)(255 - amb);
						pixel.R( (byte_t)( (amb * itsBG.R() + ami * (word_t)pixel.R()) / 255 ) );
						pixel.G( (byte_t)( (amb * itsBG.G() + ami * (word_t)pixel.G()) / 255 ) );
						pixel.B( (byte_t)( (amb * itsBG.B() + ami * (word_t)pixel.B()) / 255 ) );
					}
					aP.Pixel( x + xp, y + aY, pixel );
				}
			}
			xp += DRAWER_FONT_W;
			ps++;
		}
	}
}

// --------------------------------------------------------------------
// public:	Dimensions of the image
// --------------------------------------------------------------------
dword_t	CPictureDrawerText::W( void ) const {
	return itsText != NULL ? DRAWER_FONT_W * ::strlen( itsText ) : 0;
}

// --------------------------------------------------------------------
dword_t	CPictureDrawerText::H( void ) const {
	return itsText != NULL ? ( *itsText != 0 ? DRAWER_FONT_H : 0 ) : 0;
}

// --------------------------------------------------------------------
// public:	Set teh text
// --------------------------------------------------------------------
void	CPictureDrawerText::Text	( const char * aText ) {
	if	( itsText )	delete [] itsText;
	itsText = ::my_private_strdup( aText );
}

// --------------------------------------------------------------------
// private:	Free occupied resources
// --------------------------------------------------------------------
void	CPictureDrawerText::Free	( void ) {
	if	( itsText )	delete [] itsText;
	CPictureDrawerText::Cleanup();
}

// --------------------------------------------------------------------
// private:	Clean up teh mess
// --------------------------------------------------------------------
void	CPictureDrawerText::Cleanup	( void ) {
	itsText		= NULL;
	itsFG.RGBA( 0, 0, 0, 0 );
	itsBG.RGBA( 0, 0, 0, 0 );
}

// --------------------------------------------------------------------
// EOF: CPictureFilterScale.cxx
// --------------------------------------------------------------------
