// --------------------------------------------------------------------
// CSpam.hxx
// Whatis:	Class for detecting spam
// Authors:	Esko 'Varpu' Ilola	EIL
// History:	EIL	20-APR-2003		Created	this source
// --------------------------------------------------------------------
#ifndef	CSpam_hxx
#define	CSpam_hxx

#include	"Platform.hxx"

// --------------------------------------------------------------------
// Declaration of the CSpam class
// --------------------------------------------------------------------
class	CSpam {

	// ----------------------------------------------------------------
	public:		// Constructors
	// ----------------------------------------------------------------
	CSpam ( const char *	aIpAddress,		// Caller address
			const char *	aSpamLine,		// Function requested
			dword_t			aMinDelay );	// Minimum delay between calls

	// ----------------------------------------------------------------
	public:		// Destructor
	// ----------------------------------------------------------------
	~CSpam() {}

	// ----------------------------------------------------------------
	private:	// Copy	constructor	and	assignment operators are lethal
				// and therefore made private (won't compile if	used)
	// ----------------------------------------------------------------
	CSpam					( const CSpam & );
	CSpam & operator	=	( const CSpam & );
};

#endif	// #ifdef  CSpam_hxx
// --------------------------------------------------------------------
// EOF:	CSpam.hxx
// --------------------------------------------------------------------
