// --------------------------------------------------------------------
// CDeflate.hxx
// Whatis:	Deflate compressor
// Authors:	Esko 'Varpu' Ilola	EIL
//			Jean-loup Gailly
// History:	EIL	22-JUN-2003		Created	this source, based on work of
//								Jean-loup Gailly
// --------------------------------------------------------------------
// You should NOT include this file to your code. Use CZip.hxx instead.
// --------------------------------------------------------------------
#ifndef	CDeflate_hxx
#define	CDeflate_hxx

#include	"ICodec.hxx"
#include	"zlib.h"

// --------------------------------------------------------------------
// Declaration of the CDeflate class
// --------------------------------------------------------------------
class	CDeflate : public ICodec {

	// ----------------------------------------------------------------
	public:		// Constructor & destructor
	// ----------------------------------------------------------------
	CDeflate	();
	~CDeflate	();

	// ----------------------------------------------------------------
	public:		// Interface - instantiation from ICodec
	// ----------------------------------------------------------------
	void		Compress	( codec_stream_t & );
	void		Decompress	( codec_stream_t & );
    bool		End			( codec_stream_t & );

	// ----------------------------------------------------------------
	public:		// Accessing instance data
	// ----------------------------------------------------------------

	// ----------------------------------------------------------------
	private:	// Private helpers
	// ----------------------------------------------------------------

	// ----------------------------------------------------------------
	private:	// Instance data
	// ----------------------------------------------------------------
	z_stream	itsZS;
    bool		itsHS;
    bool		itsDM;
};

#endif	// #ifdef  CDeflate_hxx
// --------------------------------------------------------------------
// EOF:	CDeflate.hxx
// --------------------------------------------------------------------
